<div class="builder">
  <div class="complex-factory">
    <table mat-table [dataSource]="complexFactories" class="factories" cdkDropList (cdkDropListDropped)="onListDrop($event)">
      <ng-container matColumnDef="sorting">
        <th mat-header-cell *matHeaderCellDef>
          <mat-icon>drag_indicator</mat-icon>
        </th>
        <td mat-cell class="drag-handle" *matCellDef="let element">
          <mat-icon cdkDragHandle>drag_indicator</mat-icon>
        </td>
      </ng-container>

      <ng-container matColumnDef="active">
        <th mat-header-cell *matHeaderCellDef>Active</th>
        <td mat-cell *matCellDef="let element; let i = index">
          <mat-checkbox class="example-margin" [checked]="element.active" (change)="updateComplexFactoryActive(i, $event.checked)"></mat-checkbox>
        </td>
      </ng-container>

      <ng-container matColumnDef="quantity">
        <th mat-header-cell *matHeaderCellDef>Quantity</th>
        <td mat-cell *matCellDef="let element; let i = index">
          <input type="number" matInput [ngModel]="element.quantity" (ngModelChange)="updateComplexFactoryQuantity(i, $event)">
        </td>
      </ng-container>

      <ng-container matColumnDef="name">
        <th mat-header-cell *matHeaderCellDef>Name</th>
        <td mat-cell *matCellDef="let element">{{element.name}}</td>
      </ng-container>

      <ng-container matColumnDef="tier">
        <th mat-header-cell *matHeaderCellDef>Tier</th>
        <td mat-cell *matCellDef="let element; let i = index">
          <mat-select [value]="element.tier" (selectionChange)="updateComplexFactoryTier(i, $event.value)">
            <mat-option *ngFor="let tier of factoryTiers(element.name)" [value]="tier">{{tier}}</mat-option>
          </mat-select>
        </td>
      </ng-container>

      <ng-container matColumnDef="ratio">
        <th mat-header-cell *matHeaderCellDef>Suns/Yield</th>
        <td mat-cell *matCellDef="let element; let i = index">
          <mat-select *ngIf="element.allowSunMultiplier" [value]="element.sunPercent" (selectionChange)="updateComplexFactorySuns(i, $event.value)">
            <mat-option *ngFor="let sunPercent of sunPercents" [value]="sunPercent">{{sunPercent}}%</mat-option>
          </mat-select>
          <input type="number" *ngIf="element.allowAsteroidYield" matInput [ngModel]="element.yield" (ngModelChange)="updateComplexFactoryYield(i, $event)">
        </td>
      </ng-container>

      <ng-container matColumnDef="cycle">
        <th mat-header-cell *matHeaderCellDef>Cycle</th>
        <td mat-cell *matCellDef="let element"> {{element.cycle * 1000 | date:'HH:mm:ss':'UTC'}} </td>
      </ng-container>

      <ng-container matColumnDef="actions">
        <th mat-header-cell *matHeaderCellDef></th>
        <td mat-cell *matCellDef="let i = index">
          <button mat-button (click)="deleteComplexFactory(i)">
            <mat-icon>delete</mat-icon>
          </button>
        </td>
      </ng-container>

      <tr mat-header-row *matHeaderRowDef="complexFactoriesColumns"></tr>
      <tr mat-row *matRowDef="let row; columns: complexFactoriesColumns;" cdkDrag cdkDragLockAxis="y"></tr>
    </table>

    <mat-form-field appearance="fill">
      <mat-label>Choose a Factory</mat-label>
      <input type="text" placeholder="Pick one" aria-label="Number" matInput [formControl]="factoryControl" [matAutocomplete]="auto">
      <mat-autocomplete #auto="matAutocomplete" (optionSelected)="filterAddFactoryTier($event.option.value); factorySelectTier.value = ''">
        <mat-option *ngFor="let option of factoryControlOptions | async" [value]="option.name">
          {{option.name}}
        </mat-option>
      </mat-autocomplete>
    </mat-form-field>
    <mat-form-field appearance="fill">
      <mat-label>Choose the Tier</mat-label>
      <mat-select #factorySelectTier>
        <mat-option *ngFor="let tier of addFactoryTiers " [value]="tier">{{tier}}</mat-option>
      </mat-select>
    </mat-form-field>
    <button mat-flat-button color="primary" (click)="addFactory(factoryControl.value, factorySelectTier.value)">Add</button>
  </div>
  <div class="complex-production">
    <table mat-table [dataSource]="complexProduction" class="production">

      <ng-container matColumnDef="name">
        <th mat-header-cell *matHeaderCellDef> Name </th>
        <td mat-cell *matCellDef="let element"> {{element.name}} </td>
      </ng-container>

      <ng-container matColumnDef="quantity">
        <th mat-header-cell *matHeaderCellDef>Quantity per hour</th>
        <td mat-cell *matCellDef="let element" [ngClass]="{'positive': element.quantity > 0, 'negative': element.quantity < 0}">{{element.quantity | number:'1.0-0'}}</td>
      </ng-container>

      <ng-container matColumnDef="storage">
        <th mat-header-cell *matHeaderCellDef>Storage</th>
        <td mat-cell *matCellDef="let element">{{element.storage | number }}</td>
      </ng-container>

      <tr mat-header-row *matHeaderRowDef="complexProductionColumns"></tr>
      <tr mat-row *matRowDef="let row; columns: complexProductionColumns;"></tr>
    </table>
  </div>
</div>
